
package de.codedo.conflicteditor.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.HeadlessException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableModel;

public class ConflictEditorFrame extends JFrame
{
    private JTextField _databaseUrlTextField;
    private JButton _connectButton;
    private JList _conflictsList;
    private JTable _differencesTable;

    public ConflictEditorFrame() throws HeadlessException
    {
        super();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new BorderLayout());
        buildGui();
    }

    private void buildGui()
    {
        buildDatabaseUrlPanel();
        buildConflictsListAndDifferencesTable();
    }

    private void buildDatabaseUrlPanel()
    {
        JLabel label = new JLabel("Database URL:");
        _databaseUrlTextField = new JTextField(40);
        _connectButton = new JButton("Connect");

        JPanel databaseUrlPanel = new JPanel();
        databaseUrlPanel.setLayout(new FlowLayout());
        databaseUrlPanel.add(label);
        databaseUrlPanel.add(_databaseUrlTextField);
        databaseUrlPanel.add(_connectButton);

        getContentPane().add(databaseUrlPanel, BorderLayout.NORTH);
    }

    private void buildConflictsListAndDifferencesTable()
    {
        buildConflictsList();
        buildDifferencesTable();

        JScrollPane conflictsScrollPane = new JScrollPane(_conflictsList);
        JScrollPane differencesScrollPane = new JScrollPane(_differencesTable);

        JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        splitPane.add(conflictsScrollPane);
        splitPane.add(differencesScrollPane);
        getContentPane().add(splitPane, BorderLayout.CENTER);
    }

    private void buildConflictsList()
    {
        _conflictsList = new JList();
    }

    private void buildDifferencesTable()
    {
        _differencesTable = new JTable();
        _differencesTable.setDefaultRenderer(Object.class, new SpecialCharactersTableCellRenderer());

        TableModel model = new DifferenceTableModel();
        _differencesTable.setModel(model);
    }

    public String getDatabaseUrl()
    {
        return _databaseUrlTextField.getText();
    }

    public JButton getConnectButton()
    {
        return _connectButton;
    }

    public JList getConflictsList()
    {
        return _conflictsList;
    }

    public JTable getDifferencesTable()
    {
        return _differencesTable;
    }
}
